var feed = {title:"Apfeltalk News", top:"Apfeltalk News", bottom:"DE", url:"http://www.apfeltalk.de/forum/external.php?type=RSS2"};			
	var defaultIndex = 0;	
var scrollArea, scrollbar;

function colorChanged(obj) {
	document.getElementById("front").style.background = "url(" + obj.value + ")";
	widget.setPreferenceForKey(obj.value, 'color');
}
function load ()
{
	if (widget.preferenceForKey('color') == null) {widget.setPreferenceForKey('Default.png', 'color');}
	scrollbar = new AppleVerticalScrollbar(document.getElementById("myScrollBar"));
	scrollArea = new AppleScrollArea(document.getElementById("contents"), scrollbar);
	scrollArea.scrollsHorizontally = false;
	scrollArea.singlepressScrollPixels = 15;
		scrollArea.focus(); // for key control when first loading in Safari
	window.onfocus = function () { scrollArea.focus(); }
	window.onblur = function () { scrollArea.blur(); }
	document.getElementById("front").style.background = "url(" + widget.preferenceForKey('color') + ")";
	if (widget.preferenceForKey('color') == "Default.png") {document.getElementById("colorPopup").options[0].selected = true;}
	if (widget.preferenceForKey('color') == "Green.png") {document.getElementById("colorPopup").options[1].selected = true;}
	else {document.getElementById("colorPopup").options[2].selected = true;}
	//document.getElementById("search_label").innerText = document.getElementById("popup").options[defaultIndex].text;
	//window.onfocus = function () { document.getElementById("myscrollbar").focus(); }
}
function changed (select)
{
    if ( defaultIndex != select.selectedIndex)
	{
	defaultIndex = select.selectedIndex;
	document.getElementById("searchParent").innerHTML = '<input name="search" type="search" id="search-input" onkeydown="keydown(event, this);" results="5" size="17" placeholder="' + document.getElementById("popup").options[defaultIndex].text + '">';
	//cument.getElementById("search-input").focus();
}
}

function search (input)
{
	var id_rl = document.getElementById("popup").selectedIndex;
	var value = input.value;
	if (value.length > 0)
	{
		value = encodeURIComponent(value);
		
		if (id_rl == 0) {
		var url = "http://www.apfeltalk.de/forum/search.php?do=process&query=" + value + "";
		}
		if (id_rl == 1) {
		var url = "http://www.apfeltalk.de/forum/memberlist.php?ausername=" + value + "";
		}
		if (id_rl == 2) {
		var url = "http://www.apfeltalk.de/forum/search.php?query=" + value + "";
		}
	}
		
		if (window.widget)
		{
			widget.openURL (url);
		}
document.getElementById("search-input").focus();
}

function keydown (event, input)
{
	if (event.keyCode == 13) // enter or return
	{
		search (input);
	}
}

var last_updated = 0;
var xml_request = null;

//---------------------------------------------------------------------------------------------
//
// show - post a request to get Apple RSS Hot News when showing the widget. Space requests by
//		  at least 15 minutes to avoid hitting the server too often. Also, note that you should
//		  cancel any outstanding request before posting the new one. 
//
//----------------------------------------------------------------------------------------------
function show ()
{
	var now = (new Date).getTime();
	
	// only check if 15 minutes have passed
	if ((now - last_updated) > 5000)
	{
		if (xml_request != null)
		{
			xml_request.abort();
			xml_request = null;
		}
		xml_request = new XMLHttpRequest();

		xml_request.onload = function(e) {xml_loaded(e, xml_request);}
		xml_request.overrideMimeType("text/xml");
		xml_request.open("GET", feed.url);
		xml_request.setRequestHeader("Cache-Control", "no-cache");
		xml_request.send(null);
    }
}

if (window.widget)
{
	widget.onshow = show;
}


//---------------------------------------------------------------------------------------------
//
// findChild - scan the children of a given DOM element for a node matching nodeName; much more
//				efficient than the standard DOM methods (getElementsByTagName, etc) if you know
//				what you're looking for
//
//----------------------------------------------------------------------------------------------
function findChild (element, nodeName)
{
	var child;
	
	for (child = element.firstChild; child != null; child = child.nextSibling)
	{
		if (child.nodeName == nodeName)
			return child;
	}
	return null;
}

//---------------------------------------------------------------------------------------------
//
// xml_loaded - extract the content of Apple RSS Hot News feed and place the items data into a
//			    results array: extract the title, link and publication date for each item. 
//
//----------------------------------------------------------------------------------------------

function xml_loaded (e, request) 
{
	xml_request = null;
	if (request.responseXML)
	{		
		var contents = document.getElementById('contents');
		while (contents.hasChildNodes())
		{
			contents.removeChild(contents.firstChild);
		}
		
		// Get the top level <rss> element 
		var rss = findChild(request.responseXML, 'rss');
		if (!rss) {
			alert("no <rss> element"); 
			document.getElementById("ohnoes").style.display = "block";
			return;
		}
		
		// Get single subordinate channel element
		var channel = findChild( rss, 'channel');
		if (!channel) {
			alert("no <channel> element");
			document.getElementById("ohnoes").style.display = "block";
			return;
		}
		
		
		document.getElementById("ohnoes").style.display = "none";

		var results = new Array;
		
		// Get all item elements subordinate to the channel element
		// For each element, get title, link and publication date. 
		// Note that all elements of an item are optional. 
		for( var item = channel.firstChild; item != null; item = item.nextSibling)
		{
			if( item.nodeName == 'item' ) 
			{
				var title = findChild (item, 'title');
			
				// we have to have the title to include the item in the list 
				if( title != null ) 
				{
					var link = findChild (item, 'link');
					var pubDate = findChild (item, 'pubDate');
					results[results.length] = {title:title.firstChild.data, 
						link:(link != null ? link.firstChild.data : null), 
						date:new Date(Date.parse(pubDate.firstChild.data))
				   };
				}
			}
		}
		
		// sort by date
		results.sort (compFunc);
		
		// copy title and date into rows for display. Store link so it can be used when user
		// clicks on title
		nItems = results.length;
		var even = true;		
				
		for (var i = 0; i < nItems; ++i)
		{
			var item = results[i];
			var row = createRow (item.title, item.link, item.date, even);
			even = !even;
			
			contents.appendChild (row);
		}

		// update the scrollbar so scrollbar matches new data
		scrollArea.refresh();
		
		// set last_updated to the current time to keep track of the last time a request was posted
		last_updated = (new Date).getTime();
	}

}

//---------------------------------------------------------------------------------------------
//
// sortFunc - compare function used for sorting dates
//
//----------------------------------------------------------------------------------------------

function compFunc (a, b)
{
	if (a.date < b.date)
		return 1;
	else if (a.date > b.date)
		return -1;
	else
		return 0;

}

//---------------------------------------------------------------------------------------------
//
// createRow - add data to the next row in the widget body. Rows have alternating (light and 
//			   dark backgound). The title and date as displayed for each item. The link is used
//			   when the user clicks on a RSS title. 
//
//----------------------------------------------------------------------------------------------


function createRow (title, link, date, even)
{
	var row = document.createElement ('div');
	row.setAttribute ('class', 'row ' + (even ? 'light' : 'dark'));
	
	var title_div = document.createElement ('div');
	title_div.innerHTML = "&bull;&nbsp;" + title;
	title_div.setAttribute ('class', 'title');
	if (link != null)
	{
		title_div.setAttribute ('the_link', link);
		title_div.setAttribute ('onclick', 'clickOnTitle (event, this);');
	}
	row.appendChild (title_div);
	
	if (date != null)
	{
		var date_div = document.createElement ('div');
		date_div.setAttribute ('class', 'date');
		date_div.innerText = createDateStr (date);
		date_div.innerText = "";
		
		row.appendChild (date_div);
	}
	
	return row;	
}

function createDateStr (date)
{
	var month;
	switch (date.getMonth())
	{
		case 0: month = 'Jan'; break;
		case 1: month = 'Feb'; break;
		case 2: month = 'Mar'; break;
		case 3: month = 'Apr'; break;
		case 4: month = 'May'; break;
		case 5: month = 'Jun'; break;
		case 6: month = 'Jul'; break;
		case 7: month = 'Aug'; break;
		case 8: month = 'Sep'; break;
		case 9: month = 'Okt'; break;
		case 10: month = 'Nov'; break;
		case 11: month = 'Dez'; break;
	}	
	return month + ' ' + date.getDate();
}

//---------------------------------------------------------------------------------------------
//
// clickOnTitle - take user to the RSS link when she clicks on an article's title.  
//
//----------------------------------------------------------------------------------------------

function clickOnTitle (event, div)
{
	if (window.widget)
	{
		widget.openURL (div.the_link);
	} else document.location = div.the_link;
}

//---------------------------------------------------------------------------------------------
//
// clickOnFeedTitle - take user to the feed main web page when she clicks on the widget title. 
//
//----------------------------------------------------------------------------------------------

function clickOnFeedTitle(event)
{
	if (window.widget)
	{
			widget.openURL (feed.url);
	} else document.location = feed.url;
}

function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
		
}

function showFront(event)
{
	// your widget needs to show the front
	
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
	
}


